
/**
   Implement the simplest task graph,
   where task3 depends on task1 and task2.

       task1         task2
            \       /
             \     /
              task3
*/
public class TaskGraph_v1
{
   public static void main(String[] args) throws InterruptedException
   {
      final Task<Integer,Integer> task1 = new Task<>(1, 1, 1);
      final Task<Integer,Integer> task2 = new Task<>(2, 2, 3);
      final Task<Integer,Integer> task3 = new Task<>(3, 3, 2);

      final Thread t1 = new Thread(task1);
      final Thread t2 = new Thread(task2);
      final Thread t3 = new Thread(task3);

      t1.start();
      t2.start();
      t1.join();
      t2.join();
      t3.start();
   }
}
